﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinToolbars;
using System.Diagnostics;
using Infragistics.Documents.Reports.Report;
using Infragistics.Documents.Reports.Report.Section;

namespace UltraGridExportToPDF
{
    public partial class Form1 : Form
    {
        private Report report;
        public Form1()
        {
            InitializeComponent();

            // Add a "Export to PDF"  button in the Toolbar
            ButtonTool bt = new ButtonTool("Export to PDF");
            bt.SharedProps.DisplayStyle = ToolDisplayStyle.TextOnlyAlways;
            bt.SharedProps.Caption = "Export to PDF";
            ((Infragistics.Win.Printing.UltraPrintPreviewDialog)(ultraPrintPreviewDialog1)).ToolbarsManager.Tools.AddRange(new ToolBase[] { bt });
            ((Infragistics.Win.Printing.UltraPrintPreviewDialog)(ultraPrintPreviewDialog1)).ToolbarsManager.Toolbars[0].NonInheritedTools.AddRange(new ToolBase[] { bt });
            ((Infragistics.Win.Printing.UltraPrintPreviewDialog)(ultraPrintPreviewDialog1)).ToolbarsManager.ToolClick += new ToolClickEventHandler(ToolbarsManager_ToolClick);


            DataTable dt = new DataTable();
            for (int i = 0; i < 20; i++)
            {
                dt.Columns.Add("Column " + i.ToString(), typeof(string));
            }

            for (int k = 0; k < 500; k++)
            {
                object[] dr = new object[20];
                for (int i = 0; i < 20; i++)
                {
                    dr[i] = "Test Item " + k.ToString() + " - " + i.ToString();
                }
                dt.Rows.Add(dr);
            }

            ultraGrid1.DataSource = dt;
        }

        void ToolbarsManager_ToolClick(object sender, ToolClickEventArgs e)
        {
            if (e.Tool.Key == "Export to PDF")
            {
                ultraGridDocumentExporter1.Margins = new Infragistics.Documents.Reports.Report.PageMargins(ultraGridPrintDocument1.DefaultPageSettings.Margins.Left, ultraGridPrintDocument1.DefaultPageSettings.Margins.Top, ultraGridPrintDocument1.DefaultPageSettings.Margins.Right, ultraGridPrintDocument1.DefaultPageSettings.Margins.Bottom);
                var a = ultraGridPrintDocument1.DefaultPageSettings.PaperSize.Width;

                if (ultraGridPrintDocument1.DefaultPageSettings.Landscape) ultraGridDocumentExporter1.TargetPaperOrientation = Infragistics.Documents.Reports.Report.PageOrientation.Landscape;
                else ultraGridDocumentExporter1.TargetPaperOrientation = Infragistics.Documents.Reports.Report.PageOrientation.Portrait;
                ultraGridDocumentExporter1.TargetPaperSize = new Infragistics.Documents.Reports.Report.PageSize(ultraGridPrintDocument1.DefaultPageSettings.PaperSize.Width, ultraGridPrintDocument1.DefaultPageSettings.PaperSize.Height);


                ultraGridDocumentExporter1.AutoSize = Infragistics.Win.UltraWinGrid.DocumentExport.AutoSize.None;
                ultraGridDocumentExporter1.Export(ultraGrid1, "..\\..\\Test.pdf", Infragistics.Win.UltraWinGrid.DocumentExport.GridExportFileFormat.PDF);

                Process.Start("..\\..\\Test.pdf");
            }
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            ultraPrintPreviewDialog1.ShowDialog();
        }

        private void ultraGridPrintDocument1_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
        {
            Image image = Resource1.IG;
            float scaleX = e.Graphics.DpiX / 100f;
            float scaleY = e.Graphics.DpiY / 100f;

            Rectangle imagePrintRect = new Rectangle(0, 0, 100, 100);
            e.Graphics.DrawImage(image, 5, 20, imagePrintRect, GraphicsUnit.Pixel);
        }

        private void ultraGridDocumentExporter1_BeginExport(object sender, Infragistics.Win.UltraWinGrid.DocumentExport.BeginExportEventArgs e)
        {
            Infragistics.Documents.Reports.Report.Section.ISectionHeader header = e.Section.AddHeader();
            header.Height = 100;
            Infragistics.Documents.Reports.Report.Text.IText text = header.AddText(100, 0, 0);
            text.AddContent("My custom text only for PDF file");

            Infragistics.Documents.Reports.Graphics.Image image = new Infragistics.Documents.Reports.Graphics.Image(Resource1.IG);
            header.AddImage(image, 5,5);
        }
    }
}
